/*=================================================================================================
NOTE:
	This file implements the communication betwee host and target.
	PLEASE DO NOT make any change!
==================================================================================================*/


#include "Types.h"



/*=================================================================================================
FUNCTION: read_ctrl()          

DESCRIPTION: 
	Read the DCC control register.
   
ARGUMENTS PASSED:
	None
			
RETURN VALUE:
	U32		ctrl		- DCC control register.
==================================================================================================*/
U32 read_ctrl(void)
{
	U32 ctrl;
	
	__asm
	{
		MRC p14, 0, ctrl, c0, c0, 0
	}
	
	return ctrl;
}



/*=================================================================================================
FUNCTION: read_from_host()          

DESCRIPTION: 
	Read data from host via the DCC data register.
   
ARGUMENTS PASSED:
	None
			
RETURN VALUE:
	U32		data		- Data from host
==================================================================================================*/
U32 read_from_host(void)
{
	U32 ctrl;
	U32 data;
	
	while(1)
	{
		ctrl = read_ctrl();
		if(ctrl & 0x1)
			break;
	}
	
	__asm
	{
		MRC p14, 0, data, c1, c0, 0 
	}
	
	return data;
}



/*=================================================================================================
FUNCTION: read_ctrl()          

DESCRIPTION: 
	Write data to host via the DCC data register.
   
ARGUMENTS PASSED:
	U32		data		- [i] Data to host
			
RETURN VALUE:
	None
==================================================================================================*/
void write_to_host(U32 data)
{
	U32 ctrl;
	
	while(1)
	{
		ctrl = read_ctrl();
		if( !(ctrl&0x2) )
			break;
	}	
	
	__asm
	{
		MCR p14, 0, data, c1, c0, 0
	}
	
	return;
}


